%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [out_vec]=crc16(in_vec)


% Generator polynomial = x^16 + X^12 + X^5 + 1
crc16_poly = [16 12 5 0];
crc16 = zeros(17, 1); 
crc16(crc16_poly+1)=1;
crc16 = crc16(end:-1:1);

% Essentially, we are implementing polynomial division
b = [in_vec;zeros(16,1)];
p = zeros(17,1);


for i=1:length(b)
    p=circshift(p,-1);
    if p(1)==1
        p=xor(p,crc16);
    end
    p(length(p))=xor(p(length(p)),b(i));    
end

out_vec=[in_vec;p(2:17)];
end
