%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function bits = demap_to_bits_cce_anysym(complex_data, pdch_indices, CCE_num, N_cce)   %(complex_data, nsc, CCE_num, N_cce)
    nsc = size(pdch_indices, 1);
    %I = [];
    nsanity = nsc/2;
    sanity_check = 0;
    for ii=1:nsanity
        if( floor((ii-1)/18) >= CCE_num && floor((ii-1)/18) < CCE_num + N_cce )
            if(sign(real(complex_data(2*ii-1, 1))) == sign(real(complex_data(2*ii, 2))) && sign(imag(complex_data(2*ii-1, 1))) ~= sign(imag(complex_data(2*ii, 2))) && ...
                    sign(real(complex_data(2*ii-1, 2))) ~= sign(real(complex_data(2*ii, 1))) && sign(imag(complex_data(2*ii-1, 2))) == sign(imag(complex_data(2*ii, 1))))
                sanity_check = sanity_check + 1;
                %I = [I 2*ii-1 2*ii];
            end
        end
    end                
    
    %figure; plot(complex_data(I, :), 'bx');


    if(sanity_check ~= N_cce*18)
        fprintf(2, 'Warning: Sanity check (%d == %d) on data failed\n', sanity_check, N_cce*18);
    end

    % De-map the bits from QPSK
    bits = zeros(nsanity*4, 1);
    for ii=1:nsanity        
        bits(4*ii-3) = sign(real(complex_data(2*ii-1, 1)) + real(complex_data(2*ii, 2))); % 0
        bits(4*ii-2) = sign(imag(complex_data(2*ii-1, 1)) - imag(complex_data(2*ii, 2))); % 1
        bits(4*ii-1) = sign(real(complex_data(2*ii, 1)) - real(complex_data(2*ii-1, 2))); % 2
        bits(4*ii)   = sign(imag(complex_data(2*ii-1, 2)) + imag(complex_data(2*ii, 1))); % 3
    end
    bits = (1-bits)/2;
    
end

    
function jj = sc_to_index(ii, nfft_used)
    if(ii < 0) 
        jj = ii + nfft_used/2 + 1;
    else
        jj = ii + nfft_used/2;
    end
end


    
