%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function refs_fd = gen_fd_downlink_refsignal_accurate(n_s, l,p)
% ns -> between 0 & 19 (slot number)
% l -> between 0 & 6 (symbol #) under normal CP
nfft = 1024;
Nrb_max=110;
Nrb = 50;
nfft_used = 600;
nscrb = 12;
nrb_used = nfft_used/nscrb;
refs_fd = NaN*ones(nfft, 1);
%Ncellid = 0; % ATT=0 and Verizon=16, sprint 126
cell_params;
r_lns=get_r_lns(Ncellid,l,n_s);
vshift = mod(Ncellid, 6);

% If antenna port is 0 or 1, refs is only sent on symbol 0 or 4
if((p == 0 || p == 1) && (l ~=0 && l ~=4))
    refs_fd=[];
    fprintf(2, 'In gen_fd_downlink_refsignal: Mismatch between antenna # and symbol #\n');
    return;
end

% If antenna port is 2 or 3, refs is only sent on symbol 1
if((p == 2 || p == 3) && (l ~=1))
    refs_fd=[];
    fprintf(2, 'In gen_fd_downlink_refsignal: Mismatch between antenna # and symbol #\n');
    return;
end

% Check all cases (p - antenna port, l - symbol #)
if (p == 0)
    if (l == 0)
        v = 0;
    else
        v = 3;
    end
elseif (p == 1)
    if (l == 0)
        v = 3;
    else
        v = 0;
    end
elseif (p == 2)
    v = 3 * mod(n_s, 2);
elseif (p == 3)
    v = 3 + 3 * mod(n_s, 2);
else
    refs_fd = [];
    fprintf(2, 'In gen_fd_downlink_refsignal: Antenna # must be between 0..3\n');
    return;
end

for m = 0:2*Nrb-1    
    
    k = 6*m + mod(v+vshift, 6);
    
    ksc = -nfft_used/2 + k;
    if(ksc >= 0)
        ksc = ksc +1;
    end
    
    k_global = convert_bin_index_normal_to_fft(ksc, nfft);
    
    mp= m+Nrb_max-Nrb;
    refs_fd(k_global, 1) = r_lns(mp+1);
end
end
