%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [offset] = get_offset_4port(frame_num, slot_num, symbol_num, jump, subframe0_starts, is_extended_cp)    
    nfft = 1024;    
    slot_len = 7680;    
    
    if(nargin < 7)
        is_extended_cp = false;
    end
    
    if(is_extended_cp)
        ncp0 = 256;
        ncp1 = 256;        
    else
        ncp0 = 80;
        ncp1 = 72;          
    end        
    
    if((symbol_num == 0 && jump > ncp0) || (symbol_num > 0 && jump > ncp1) || jump < 0)
        fprintf(2, 'Warning: jump is much bigger than CP (or negative)\n');
    end
    
    offset = subframe0_starts(frame_num+1) + slot_num * slot_len + (symbol_num>0)*(nfft + ncp0) + max(0,symbol_num-1)*(nfft + ncp1) + jump - (symbol_num>0)*(ncp0 - ncp1);       
    
end
