%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pcfic_sc = get_pcfic_sc(Ncellid)
    
    nscrb = 12;
    nrbdl = 50;
    kbar = nscrb/2 * mod(Ncellid, 2*nrbdl); % function of cell ID (which is 0!)    
    nfft_used = 300;
    nsc_rg_max = 6;
    kbar_skip = floor(nrbdl/2)*(nscrb/2);
    
    pcfic_sc = (mod([ kbar+(-nfft_used: -nfft_used + nsc_rg_max -1), kbar+(-nfft_used + kbar_skip: -nfft_used + nsc_rg_max  + kbar_skip -1), ...
        kbar+(-nfft_used + 2*kbar_skip: -nfft_used + nsc_rg_max  + 2*kbar_skip -1), kbar+(-nfft_used + 3*kbar_skip: -nfft_used + nsc_rg_max  + 3*kbar_skip -1)]+nfft_used, 2*nfft_used)-nfft_used);        
    
    pcfic_sc(pcfic_sc>=0) = pcfic_sc(pcfic_sc>=0) +1;
            
    % Ignore reference signals
    pcfic_ex = [-nfft_used:-1, 1:nfft_used]; 
    pcfic_ex = pcfic_ex(mod(Ncellid, 3)+1:3:end);
    
    pcfic_sc = setdiff_orderpreserve(pcfic_sc, pcfic_ex);
    
end
