%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [pdch_bits, succ] = get_pdcch_anysym_fast(x0, x1, frame_num, subframe_num, subframe0_starts,blen,CCE_num,N_cce,pdch_indices)       
    slot_num = 2*subframe_num;
    cell_params;
    C_init = Ncellid + subframe_num*(2^9);    
    
                    
    if(~isempty(x1))    
        complex_data = invert_channel_complex(x0, x1, frame_num, slot_num, subframe0_starts, pdch_indices);
    else
        complex_data = invert_channel_siso_complex(x0, frame_num, slot_num, subframe0_starts, pdch_indices);        
    end            
    
    pdch_bits = demap_to_bits_cce_anysym(complex_data, pdch_indices, CCE_num, N_cce);
        
    
    % Scramble
    c = get_c(C_init, length(pdch_bits));    
    pdch_bits = xor(c, pdch_bits);            
        

    pdch_bits = pdch_bits(72*CCE_num+1:72*(CCE_num+N_cce));          
    
    %%%%pdch_bits = [pdch_bits(72*5+1:72*6);pdch_bits(72*4+1:72*5)];
    
    % Interleave        
    [d0, d1, d2] = interleave_lte_pdcch(pdch_bits,blen);
    [pdch_bits, succ] = decode_conv_lte_soft(d0, d1, d2);     
    %[CCE_num, N_cce]
    %succ
    %pdch_bits
        
    
    %dd = lteRateRecoverConvolutional(10*pdch_bits-5,blen*3);
    %pdch_bits = lteConvolutionalDecode(dd);
    %verify = 2*lteConvolutionalEncode(pdch_bits)-1;
    %sanity = (double(verify).*double(dd) < 0);
    %succ = (sum(sanity) == 0);
    %CCE_num
    %N_cce
    %sum(sanity)
    
    crc_bits = crc16(pdch_bits(1:end-16)).';
    
    pdch_bits(end-15:end) = xor(crc_bits(end-15:end).', pdch_bits(end-15:end));
    
    if(1)
        [crc_bits(end-15:end).', pdch_bits(end-15:end) xor(crc_bits(end-15:end).', pdch_bits(end-15:end))];
    end
    
    
end

    
function JJ = sc_to_index(II, nfft_used)
    II = reshape(II, 1, []);
    kk = 1;
    for ii=II
        if(ii < 0) 
            jj = ii + nfft_used/2 + 1;
        else
            jj = ii + nfft_used/2;
        end
        JJ(kk)=jj;
        kk = kk+1;
    end    
end
