%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GET_PDCCH_BITS Returns bits of PDCCH
% Requires: Raw I/Q samples, Frame number, Subframe number, Subframe start
% locations
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [res0, succ0, offset0] = get_pdcch_bits(x0, x1, frame_num, subframe_num, subframe0_starts)

refs_fd_indices_all = [];
sym = 0;        
nfft_used = 300;
nfft = 1024;
cell_params;

for ant=0:3
    refs_fd = gen_fd_downlink_refsignal_accurate(0, sym, ant);
    refs_fd_indices = sort(convert_bin_index_fft_to_normal(find(~isnan(refs_fd)), nfft)).';
    refs_fd_indices_all = reshape(sort(union(refs_fd_indices, refs_fd_indices_all)), 1, []);
end
pdch_indices = [0:2*nfft_used-1];
pdch_indices = pdch_indices - nfft_used;
pdch_indices(pdch_indices>=0) = pdch_indices(pdch_indices >=0)+1;       
pdch_indices = setdiff(pdch_indices, refs_fd_indices_all);
%allsc = setdiff(allsc, refs_fd_indices_all);

pdch_indices = setdiff(pdch_indices, refs_fd_indices_all);

pcfic_sc = get_pcfic_sc(Ncellid);    
pdch_indices = setdiff(pdch_indices, pcfic_sc);

phich_sc = get_phich_sc(Ncellid);    
pdch_indices = setdiff(pdch_indices, phich_sc);            

[res0, succ0, ~, offset0] = get_pdcch_blind_anysym_fast(x0, x1, frame_num, subframe_num, subframe0_starts, [43, 57], 0, pdch_indices);

end
