%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function J = get_peak_indices(x0, thresh)
    x0 = abs(x0);
    mx = max(x0);
    
    % thresh: What's the measure of a peak?
    if(nargin < 2)
        thresh = 0.9*mx;
    end
    
    % How far apart must two peaks be to not be considered part of the same
    close_thresh = 15000;
    

    I = find(x0>thresh);  
    I
    
    I_absgt = [1 , reshape((abs(x0(I(2:end)))-abs(x0(I(1:end-1)))>=0), 1, [])];
    I_abslt = [reshape((abs(x0(I(2:end)))-abs(x0(I(1:end-1)))<=0), 1, []) , 1];
    
    J = I( (I_absgt) & (I_abslt));
    
    
    J_gt = [1==1 , reshape(abs(J(2:end)-J(1:end-1))>=close_thresh, 1, [])];
    
    J = J(J_gt);
end
