%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function phich_sc = get_phich_sc(Ncellid)    
    nrbdl = 50;
    
    pcfic_sc = get_pcfic_sc(Ncellid)
    pcfic_reg = get_unique_reg(pcfic_sc)
    
    if(length(pcfic_reg)~=4)
        fprintf(2, 'Warning: Something wrong with PCFIC reg length\n');
    end
    
    all_regs = (0:2*nrbdl-1);
    rem_regs = setdiff(all_regs, pcfic_reg)
    
    
    % We assume normal PHICH & FDD & normal CP
    phich_offset = Ncellid; %floor(Ncellid*length(rem_regs)/300); %(2*nrbdl));
    phich_regs = rem_regs(mod((phich_offset + [(0:6), ((0:6)+floor(length(rem_regs)/3)), ((0:6)+floor(2*length(rem_regs)/3))]), length(rem_regs))+1)
        
    phich_sc = get_sc_from_reg(phich_regs)   
end
