%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function sc_list = get_sc_from_reg(regs)
    nfft = 1024;
    nscrb = 12;
    nrbdl = 50;       
    nfft_used = 300;
    nsc_rg_max = 6;         
    kbar_skip = floor(nrbdl/2)*(nscrb/2);
        
    sc_list = (nsc_rg_max*regs);
    
    sc_list = reshape(repmat(sc_list, 6, 1), 1, []) + repmat((0:5), 1, length(sc_list));
    
    
    sc_list = sc_list - nfft_used;
    sc_list(sc_list>=0) = sc_list(sc_list>=0) + 1;
    
    
    refs_fd_indices_all = [];
    sym = 0;
    slot_num = 0;
    for ant=0:3
        refs_fd = gen_fd_downlink_refsignal_accurate(slot_num, sym, ant);
        refs_fd_indices = sort(convert_bin_index_fft_to_normal(find(~isnan(refs_fd)), nfft)).';
        refs_fd_indices_all = reshape(sort(union(refs_fd_indices, refs_fd_indices_all)), 1, []);
    end
    
    sc_list = setdiff(sc_list, refs_fd_indices_all);

end
