%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Interleaver for LTE (used in PBCH)
function [d0, d1, d2] = interleave_lte(bits)
    blen = 120;    

	d0 = (0:39);
    d1 = (40:79);
    d2 = (80:119);
    
    v0 = get_v(d0);
    v1 = get_v(d1);
    v2 = get_v(d2);
    
    w = [v0; v1; v2];        
    
    Kw = length(w);
    
    kk = 0;
    jj = 0;
    
    e = zeros(blen, 1);
    
    while kk < blen
        if ~isnan(w(mod(jj, Kw)+1))
            e(kk+1) = w(mod(jj, Kw)+1);
            kk = kk + 1;
        end
        jj = jj + 1;
    end
    
    out_bits = round(mean(reshape(bits.', 120, []).'));
    
    d = zeros(blen, 1);
    d(e+1) = out_bits;
    % d = out_bits(e+1);
    
    d0 = d(1:40);
    d1 = d(41:80);
    d2 = d(81:120);
end


%% Get v from d
function v = get_v(d)
    y = [NaN*ones(1, 24), d];  % NaN == NULL in the LTE standard
    y = reshape(y, 32, 2).';
    p = [1,17,9,25,5,21,13,29,3,19,11,27,7,23,15,31, ...
        0,16,8,24,4,20,12,28,2,18,10,26,6,22,14,30];
    
    for ii = 1:2
        y(ii, :) = y(ii, p+1);
    end
    
    v = y(:);
end

