%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Interleaver for LTE (used in PBCH)
function [d0, d1, d2] = interleave_lte_pdcch(bits,blen)
    blen_act = length(bits); 
    blen=blen*3;

    d0 = (0:blen/3-1);
    d1 = (blen/3:2*blen/3-1);
    d2 = (2*blen/3:blen-1);	
    
    v0 = get_v(d0);
    v1 = get_v(d1);
    v2 = get_v(d2);

    
    w = [v0; v1; v2];        
    Kw = length(w);
    
    kk = 0;
    jj = 0;
    
    e = zeros(blen_act, 1);
    
    while kk < blen_act
        if ~isnan(w(mod(jj, Kw)+1))
            e(kk+1) = w(mod(jj, Kw)+1);
            kk = kk + 1;
        end
        jj = jj + 1;
    end
    %reshape(bits, 6, [])
    %out_bits = (mean(1.0*reshape(bits.', blen, []).'));
    
    out_bits = bits;
    
    d = 3*ones(blen, 1);
    d(e+1) = out_bits*7;
    % d = out_bits(e+1);
    
    d0 = d(1:blen/3);
    d1 = d(blen/3+1:2*blen/3);
    d2 = d(2*blen/3+1:blen);    
end


%% Get v from d
function v = get_v(d)
    %rem = mod(32-length(d), 32);  % added 32-
    quot = ceil(length(d)/32);
    rem = quot*32 - length(d);
    
    y = [NaN*ones(1, rem), d];  % NaN == NULL in the LTE standard
    y = reshape(y, 32, quot).';
    p = [1,17,9,25,5,21,13,29,3,19,11,27,7,23,15,31, ...
        0,16,8,24,4,20,12,28,2,18,10,26,6,22,14,30];
    
    for ii = 1:quot
        y(ii, :) = y(ii, p+1);
    end
    
    v = y(:);
end

