%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y0 = interp_signal_fast(x0,inp_bw,out_bw) 
    inp_size = length(x0)-1;
    out_size = floor(inp_size * out_bw / inp_bw);
    y0=zeros(1,out_size);
    indexes = (0:out_size-1).';
    j0=floor(indexes*inp_bw/out_bw);
    j1=ceil(indexes*inp_bw/out_bw);
    ja = indexes*inp_bw/out_bw;        
    y0s = ((x0(j1+1)-x0(j0+1)) .* (ja-j0))./(j1-j0);
    y0(indexes+1)= x0(j0+1);    
    y0(~isnan(y0s)) = y0(~isnan(y0s)) + y0s(~isnan(y0s)).';
end
