%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function out_channel = interpolate_nans(in_channel)    
    nfft = 1024;
    maxfft = 300;
    interp_size = 3;
    interp_start = min(convert_bin_index_fft_to_normal(find(~isnan(in_channel)), nfft))+maxfft+1;
    POS_USED_BINS = 1:maxfft;
    NEG_USED_BINS = -maxfft:-1;
    POS_USED_BINS_FFT = convert_bin_index_normal_to_fft(POS_USED_BINS, nfft);
    NEG_USED_BINS_FFT = convert_bin_index_normal_to_fft(NEG_USED_BINS, nfft);
    POS_NOTNAN_INDICES = POS_USED_BINS_FFT(interp_start:interp_size:end);
    NEG_NOTNAN_INDICES = NEG_USED_BINS_FFT(interp_start:interp_size:end);
    out_channel = NaN * ones(nfft, 1);
    out_channel(POS_USED_BINS_FFT) = interp(in_channel(POS_NOTNAN_INDICES), interp_size);
    out_channel(NEG_USED_BINS_FFT) = interp(in_channel(NEG_NOTNAN_INDICES), interp_size);
end
