%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Swarun Kumar, (swarun at mit.edu)
% This project is Licensed under the MIT License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function complex_data = invert_channel(x0, x1, frame_num, slot_num, sym, subcarr, subframe0_starts)
    jump = 40;   
    nfft = 1024;

    [avgchannel0, offset] = get_corrected_channel_4port(x0, frame_num, slot_num, sym, jump, subframe0_starts);
    [avgchannel1, ~] =      get_corrected_channel_4port(x1, frame_num, slot_num, sym, jump, subframe0_starts);   

    x0_fft = fft(x0(offset:offset+nfft-1));
    x1_fft = fft(x1(offset:offset+nfft-1));  

    complex_data = zeros(length(subcarr), 2);

    ii = 1;
    sclist = convert_bin_index_normal_to_fft(subcarr, nfft);
    hmat = cat(3, [avgchannel0(sclist, 1) avgchannel1(sclist, 1)], [avgchannel0(sclist, 2) avgchannel1(sclist, 2)]);
    y = [x0_fft(sclist); x1_fft(sclist)];                            
    for ii = 1:length(sclist)
        complex_data(ii, :) = (squeeze(hmat(ii, :, :)) \ y(:, ii)).';                    
    end    
end
